/**/
'@echo off'
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

player.Name='maplay.exe'
player.Options='-q'
player.list='-@ '
player.killer='go -k'
player.lister='go'


version="2.03"
usage.0=9
usage.1="Usage:"
usage.2="mp3.cmd <Directory> [-dirfile <Dirs list file>] [-random] [-descending] [-list] [-v]"
usage.3=""
usage.4="switches:"
usage.5="dirfile    - use directories playlist file"
usage.6="random     - randomize songs order;"
usage.7="descending - sort songs alphabetically in descending order;"
usage.8="list       - generate list, then play."
usage.9="v          - show version."


info.0=4
info.1="MP3/2 player v"||version
info.2="done by Sergey Gryaznov"
info.3="feel the power of rexx :)"
info.4=""

player.PID=0

controls.0=8
controls.1=""
controls.2=""
controls.3=""
controls.4="[N] Next song             [P] Previous song"
controls.5="[S] Stop playing          [X] eXit"
controls.6="[R] Restart playing"
controls.7="[O] playing Order"
controls.8=""

errors.0=2
errors.1="Invalid usage."
errors.2="<Ctrl-Break> pressed."

errorNum=0

file.0=0
seq.0=0
played.0=0
currentSong=0
needList=0
dirList=0

sequence=0 /* 0-normal,1 - normal descending, 2-random*/
listFile=""

signal on halt name error
call sysCurState 'OFF'

arguments=arg(1)

if (length(arguments)=0) then do
	errorNum=1
	signal error
end
if (isArg('-v')) then do
	errorNum=0
	signal error
end
if (isArg('-?')) | (isArg('-h')) | (isArg('/h')) | (isArg('/?')) then do
	errorNum=1
	signal error
end
if isArg('-RANDOM') then sequence=2
if isArg('-DESCENDING') then sequence=1
if isArg('-LIST') then needList=1
if isArg("-DIRFILE")=1 then dirList=1
errorNum=2 /*<Ctrl-Break>*/

if dirlist=1 then do
	say lines(arguments)
	i=0
	do while lines(arguments)>0
		i=i+1
		if i=1 then call createList linein(arguments)
			else call addList linein(arguments)
	end
	call stream arguments,'c','close'
end
else do
	call createList arguments
end

call sortList sequence
playSuspended=0
if needList=1 then do
	call playList
	errorNum=0
	signal error
end

userNSC=0
do forever
	if (playCheck()=0) & (playSuspended=0) then do
		if userNSC=0 then do
			do forever
				currentSong=currentSong+1
				if currentSong>seq.0 then do
					errorNum=0
					signal error
				end
				fname=seq.Currentsong
				if played.fname=0 then leave
			end
		end
		userNSC=0
		call drawScreen
		call playStart
		call drawInfo
	end
	do i=1 to 20
		rc=chars()
		if rc>0 then do
			userResponse=substr(strip(translate(SysGetKey('NOECHO'))),1,1)
			select
				when userResponse="X" then do
					call playStop
					call sysCls
					exit
				end
				when userResponse="N" then do
					currentSong=currentSong+1
					if currentSong>seq.0 then currentSong=0
					userNSC=1
					call drawList
				end
				when userResponse="P" then do
					currentSong=currentSong-1
					if currentSong<=0 then currentSong=seq.0
					userNSC=1
					call drawList
				end
				when userResponse="S" then do
					call playStop
					playSuspended=1
				end	
				when userResponse="R" then do
					call playStop
					playSuspended=0
					userNSC=1
				end
				when userResponse="O" then do
					sequence=sequence+1
					if sequence>2 then sequence=0
					call playStop
					call sortList sequence
					userNSC=1
				end
				otherwise
			end
		end
		else do
			call SysSleep 0.1
		end
	end
end
exit

error:
	call playStop
	call sysFileDelete listFile
	call sysCls
	call showError
	call sysCurState 'ON'
	exit

isArg:procedure expose arguments
	parse arg option
	option=translate(option)
	if (pos(option,translate(arguments))>0) then do
		rc=1 
	end
	else do
		rc=0
	end
	if rc=1 then 
		arguments=strip(delstr(arguments,pos(option,translate(arguments)),length(option)))
return rc

playList:procedure expose listFile file. seq. player.
	call listWrite
	call sysCurPos 0,0
	'detach '||player.Name||' '||player.Options||' '||player.List||listFile
	str=sysTextScreenRead(0,0,44)
	parse value str with "The Process Identification Number is " player.PID "."
	call sysCls
	say "Playing list <Ctrl-Break> to quit."
	rc=1
	do while (rc>0)
		rc=playCheck()
		if rc>0 then call sysSleep 5
	end
return

playStart:procedure expose CurrentSong file. seq. played. player.
	if player.PID>0 then call playStop

	fname=seq.currentSong
	played.fname=1
	fname=file.fname
	call sysCurPos 0,0

	'detach '||player.Name||' '||player.Options||' '||D2C(34)||fname||D2C(34)
	str=sysTextScreenRead(0,0,44)
	parse value str with "The Process Identification Number is " player.PID "."
return

playCheck:procedure expose player.
	rc=0
	if player.PID>0 then do
		NewQueue=RxQueue('create')
		OldQueue=RxQueue('set',NewQueue)
		player.lister ||' | RXQUEUE '||NewQueue
		do while queued() > 0
			parse pull pPID . someStuff
			if pPID=player.PID then rc=1
		end
		call RxQueue 'delete', NewQueue
		call RxQueue 'set'   , OldQueue
	end
	if rc=0 then player.PID=0
return rc

playStop:procedure expose player.
	if player.PID=0 then return
	player.killer||' '||player.PID||' >NUL'
	rc=1
	do while (rc>0)
		rc=playCheck()
		call sysSleep(0.1)
	end
	player.PID=0
return

listWrite:procedure expose listFile file. seq.
	listFile=sysTempFileName(value("TMP",,"OS2ENVIRONMENT")||'\pl?????.lst')
	call stream listFile,'c','open write'
	do i=1 to file.0
		fname=seq.i
		fname=file.fname
		call lineOut listFile,fname
	end
	call stream listFile,'c','close'
return

drawScreen:procedure expose controls. CurrentSong file. seq. played.
	call sysCls
	call drawInfo
	call drawControls
	call drawList
return

drawInfo: procedure expose currentSong file. seq.
	call sysCurPos 0,0

	parse value SysTextScreenSize() with MaxRow MaxCol

	if currentSong>0 then do
		fname=seq.currentSong
		fname=file.fname

		fdir=filespec("path",fname)
		fdir=delstr(fdir,1,1)
		fdir=delstr(fdir,length(fdir),1)

	    rnum=delstr(fname,1,pos('.',fname))
		rnum=substr(rnum,1,1)
	    fname=delstr(fname,pos('.',fname),length(fname)-pos('.',fname)+1)
		fname=delstr(fname,1,lastpos('\',fname))

		say substr("Playing albom:   "||fdir,1,maxCol-3)
		say substr("Playing song "||rnum||":  "||fname,1,maxCol-3)
	end
return

drawControls: procedure expose controls.
	call sysCurPos 0,0
	parse value SysTextScreenSize() with MaxRow MaxCol
	do i=1 to controls.0
		say substr(controls.i,1,maxCol-3)
	end
return

drawList: procedure expose file. seq. played. controls. currentSong
	call sysCurPos controls.0,0
	   
	parse value SysTextScreenSize() with MaxRow MaxCol
	sfile=trunc((MaxRow-(controls.0+1))/2)
	if (sfile>currentSong) | (sfile<=0) then do
		sfile=1 
	end	
	else do
		sfile=currentSong-sfile
	end
	if ((seq.0-sfile)<(MaxRow-(controls.0+1))) then sfile=seq.0-(MaxRow-(controls.0+2))
	if sfile<=0 then sfile=1
	do i=1 to MaxRow-(controls.0+1)
		fname_num=seq.sfile
		fname=file.fname_num
		prechar=" "
		if played.fname_num=1 then prechar="+"
		if sfile=currentSong then prechar="*"

	    fname=delstr(fname,pos('.',fname),length(fname)-pos('.',fname)+1)
		fname=delstr(fname,1,lastpos('\',fname))

		say prechar||' '||substr(fname,1,maxCol-3)
		sfile=sfile+1
		if sfile>seq.0 then leave
	end
return

sortList: procedure expose file. seq. 
	parse arg sequence
	seq.0=file.0
	
	do i=1 to seq.0
		seq.i=i
	end

	select
		when (sequence=0) | (sequence=1) then do
			rfnum.0=seq.0
			rfdirname.0=seq.0
			do i=1 to seq.0
				rfdirname.i=translate(filespec("path",file.i))
				fname=filespec("name",file.i)
				fname=delstr(fname,pos('.MP3',translate(fname)),4)
				if (pos('.',fname)>0) then rfnum.i=X2D(C2X(translate(delstr(fname,1,pos('.',fname)))))
					else rfnum.i=255
			end
			do i=1 to seq.0
				min=256
				k=i
				do j=1 to seq.0
					if (rfnum.j<min) & (rfdirname.j=rfdirname.k) then do
						min=rfnum.j
						k=j
					end
				end
	 			rfnum.k=65535
				seq.i=k
			end
			drop rfnum
			drop rfdirname
			if sequence=1 then do
				do i=1 to trunc(seq.0/2)
					k=seq.i
					j=seq.0-i+1
					seq.i=seq.j
					seq.j=k
				end
			end
		end

	when (sequence=2) then do
		
		rnd=Random(1,65535,TIME('S'))

		do i=1 to seq.0
			selected=0
			do while (selected=0)
				selected=1
				rnd=Random(1,seq.0)
				do j=1 to i-1
					if (rnd=seq.j) then selected=0
				end
			end
			seq.i=rnd
		end
	end
	otherwise 
	end
return

addList: procedure expose file. played.
	parse arg dir

	
	do while pos('"',dir)<>0
		dir=delstr(dir,pos('"',dir),1)
	end
	if substr(dir,length(dir),1)='\' then 
	dir=delstr(dir,length(dir),1)

	call SysFileTree dir||"\*.mp3",'newFile','FOS'

	j=file.0
	
	do i=1 to newFile.0
		j=j+1
		played.j=0
		file.j=newFile.i
	end
	file.0=j
	played.0=j
	drop newFile
return

createList: procedure expose file. played.
	parse arg dir
	
	do while pos('"',dir)<>0
		dir=delstr(dir,pos('"',dir),1)
	end
	if substr(dir,length(dir),1)='\' then 
	dir=delstr(dir,length(dir),1)

	call SysFileTree dir||"\*.mp3",'file','FOS'

	played.0=file.0
	do i=1 to played.0
		played.i=0
	end
return

showError: procedure expose errorNum errors. info. usage.
	if (errorNum<0) | (errorNum>255) then errName="MPP0255"
	if (errorNum>0) & (errorNum<10) then errName="MPP000"||errorNum
	if (errorNum>9) & (errorNum<100) then errName="MPP00"||errorNum
	if (errorNum>99) then errName="MP0"||errorNum
	if errorNum>errors.0 then do
		say errName
		say "MPP0255: error message not defined"
		exit
	end
	else do
		if errorNum>0 then say errName||": "||errors.errorNum
	end
	select
		when errorNum=0 then do
			call showHelp
		end
		when errorNum=1 then do
			call showUsage
		end
	otherwise
	end
return

showHelp: procedure	expose info.

	do i=1 to info.0
		say info.i
	end

return

showUsage: procedure expose usage. info.

	do i=1 to usage.0
		say usage.i
	end
return